#ifndef MAINWIDGET_H
#define MAINWIDGET_H

#include <QWidget>
#include <QListWidgetItem>
#include <QList>
#include <QMessageBox>
#include <QTime>
#include <QFile>
#include <QProgressDialog>
#include <QDir>
#include <QDebug>
#include <QFileDialog>
#include <QScrollBar>
#include <QKeyEvent>
#include <QDate>
#include <QDesktopServices>
#include <QPropertyAnimation>

namespace Ui {
class MainWidget;
}

class MainWidget : public QWidget
{
    Q_OBJECT

public:
    explicit MainWidget(QString username,QWidget *parent = nullptr);
    ~MainWidget();
    void sendFile(QString filePath,QString filename,QString name = "");
    void readFile(QString filename,QByteArray data);
    bool eventFilter(QObject *target, QEvent *event);

signals:
    void send_text(QString sendname,QString text);
    void send_to_user(QString sendname,QString to_user,QString test);
    void send_file_to_all(QString sendname,QString filename,QByteArray file);
    void send_file_private(QString sendname,QString filename,QByteArray file,QString name);
    void exit_client();
    void update_namelist(QString username);
    void account_cancellation(QString username);

private slots:
    void on_send_text_clicked();
    void on_save_btn_clicked();
    void on_send_btn_clicked();
    void on_name_list_itemDoubleClicked(QListWidgetItem *item);
    void on_exit_btn_clicked();
    void on_stop_clicked();
public slots:
    void update_text(QString sendname,QString data);
    void update_file(QString sendname,QString filename,QString file_data);
    void update_file_private(QString sendname,QString filename,QString file_data);
    void update_users(int count,QList<QString>online_users);
    void disconnect_form_server();

private:
    Ui::MainWidget *ui;
    QString username;
    void zoom_up(QPushButton* btn);
    void zoom_down(QPushButton* btn);
};

#endif // MAINWIDGET_H
